#include "os.h"
#include "paging.h"
#include "kheap.h"

//TEST
extern heap_t* kheap;
//TEST

int main()
{
    k_clear_screen();
    gdt_install(); idt_install();
    isrs_install(); irq_install(); ODA_install();
    sti();
    timer_install();
    keyboard_install();
    paging_install();
    kheap = heap_install();

    //TEST
    printformat("kernel ends at: %x\n", get_end_kernel());
    printformat("&kheap: %x kheap->start %x kheap->end %x\n",
                 &kheap, kheap->start_address, kheap->end_address);
    ULONG addr = k_malloc(0x100000,1,0);
    printformat("&kheap: %x kheap->start %x kheap->end %x\n",
                 &kheap, kheap->start_address, kheap->end_address);
    kfree((ULONG*)addr);
    printformat("&kheap: %x kheap->start %x kheap->end %x\n",
                 &kheap, kheap->start_address, kheap->end_address);

    //TEST

    return 0;
};
